## `swap`

Exchange the given values.

### Synopsis

Defined in header <boost/json/string.hpp>.

    void
    swap(
        string& lhs,
        string& rhs);

### Description

Exchanges the contents of the string `lhs` with another string `rhs`. Ownership of the respective `boost::container::pmr::memory_resource` objects is not transferred.

- If `&lhs == &rhs`, do nothing. Otherwise,

- if `*lhs.storage() == *rhs.storage()`, ownership of the underlying memory is swapped in constant time, with no possibility of exceptions. All iterators and references remain valid. Otherwise,

- the contents are logically swapped by making a copy, which can throw. In this case all iterators and references are invalidated.

### Effects

    lhs.swap( rhs );

### Complexity

Constant or linear in `lhs.size() + rhs.size()`.

### Exception Safety

Strong guarantee. Calls to `memory_resource::allocate` may throw.

### Parameters

Name | Description
--- | ---
`lhs` | The string to exchange.
`rhs` | The string to exchange.

### See Also

`string::swap`

Convenience header <boost/json.hpp>

Edit this page